unit guidance;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, DBDateTimePicker, Forms, Controls, Graphics,
  Dialogs, DbCtrls, ExtCtrls, StdCtrls, Buttons, DBGrids, ComCtrls,
  db, IBConnection, Types, Grids;

type

  { TfrmGuidance }

  TfrmGuidance = class(TForm)
    btnAddComment: TBitBtn;
    btnAddComment1: TBitBtn;
    btnAddComment2: TBitBtn;
    BtnAddTodo: TBitBtn;
    BtnAddTodo1: TBitBtn;
    BtnAddTodo2: TBitBtn;
    BtnAddTodo3: TBitBtn;
    btnDeleteComment: TBitBtn;
    btnDeleteComment1: TBitBtn;
    btnDeleteComment2: TBitBtn;
    btnDeleteToDo: TBitBtn;
    btnDeleteToDo1: TBitBtn;
    btnDeleteToDo2: TBitBtn;
    btnDeleteToDo3: TBitBtn;
    btnEditComment: TBitBtn;
    btnEditComment1: TBitBtn;
    btnEditComment2: TBitBtn;
    btnEditTodo: TBitBtn;
    btnEditTodo1: TBitBtn;
    btnEditTodo2: TBitBtn;
    btnEditTodo3: TBitBtn;
    btnReviewDiv1: TBitBtn;
    btnReviewDiv2: TBitBtn;
    btnReviewDiv3: TBitBtn;
    btnReviewTrust1: TBitBtn;
    btnReviewTrust2: TBitBtn;
    btnReviewTrust3: TBitBtn;
    dbgReviewDir3: TDBGrid;
    dbgReviewDir4: TDBGrid;
    dbgReviewDir5: TDBGrid;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBGrid3: TDBGrid;
    DBGrid4: TDBGrid;
    DBGrid5: TDBGrid;
    DBGrid6: TDBGrid;
    DBGrid7: TDBGrid;
    DBLookupComboBox1: TDBLookupComboBox;
    DBLookupComboBox2: TDBLookupComboBox;
    dbmComment: TDBMemo;
    dbmComment1: TDBMemo;
    dbmComment2: TDBMemo;
    dbmDir1: TDBMemo;
    dbmDir2: TDBMemo;
    dbmDiv1: TDBMemo;
    dbmDiv2: TDBMemo;
    dbmTrust1: TDBMemo;
    dbmTrust2: TDBMemo;
    grbDiv1: TGroupBox;
    grbDiv2: TGroupBox;
    grbTrust1: TGroupBox;
    grbTrust2: TGroupBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    pclReview: TPageControl;
    pgeFacilitator: TTabSheet;
    pgeFacilitator1: TTabSheet;
    pgeReview: TTabSheet;
    pgeReview1: TTabSheet;
    procedure btnDeleteToDoClick(Sender: TObject);
    procedure btnDeleteCommentClick(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure FormShow(Sender: TObject);
    procedure OpenComment(Sender:TObject);
    procedure PrepareDBGridCanvas(sender: TObject; DataCol: Integer;
      Column: TColumn; AState: TGridDrawState);
    procedure DBGridOnGetText(Sender: TField; var aText: string; DisplayText: Boolean);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  frmGuidance: TfrmGuidance;

implementation

{$R *.lfm}

uses gdlmod, mainmod, comment;
 { TfrmGuidance }

procedure TfrmGuidance.OpenComment(Sender: TObject);
 var
   frmComment :TfrmComment;
 begin
   try
     frmComment :=TfrmComment.Create(Sender as TControl);
     frmComment.ShowModal;
   finally
     frmComment.Release;
   end;
 end;

procedure TfrmGuidance.btnDeleteCommentClick(Sender: TObject);
begin
  try
    begin
      dmGuidance.qryFacCom.Delete;
      dmGuidance.qryFacCom.ApplyUpdates();
      dmMain.trnMain.Commit;
      dmGuidance.qryFacCom.Active:=False;
 //     dmGuidance.ActivateDatasets();
    end;
  finally
  end;
end;

procedure TfrmGuidance.btnDeleteToDoClick(Sender: TObject);
begin
  try
    begin
      dmGuidance.qryTodo.Delete;
      dmMain.trnMain.Commit;
//      dmGuidance.ActivateDatasets();
    end;
  finally
  end;
end;

procedure TfrmGuidance.DBGrid1CellClick(Column: TColumn);
begin
  case UPCASE(Column.FieldName) of
    'COMPLETED':
    if Column.Field.Value = 1 then
      begin
        dmGuidance.qryTodo.FieldByName('datecomplete').AsDateTime:=Date;
        dmGuidance.qryTodo.ApplyUpdates;
        dmMain.trnMain.Commit;
      end
    else
      begin
        dmGuidance.qryTodo.FieldByName('datecomplete').Value:= Null;
        dmGuidance.qryTodo.ApplyUpdates;
        dmMain.trnMain.Commit;
      end;
  end;

end;

procedure TfrmGuidance.FormShow(Sender: TObject);
begin
  dmMain.conGov.Connected:=True;
  dmGuidance.qryFacCom.Active:=True;
  dmGuidance.qryTodo.Active:=True;
end;

procedure TfrmGuidance.PrepareDBGridCanvas(sender: TObject; DataCol: Integer;
  Column: TColumn; AState: TGridDrawState);
  var
    MyTextStyle: TTextStyle;
  begin
    // Here you choose what column will be affected (the columns of the DBGrid not SQL).
    if (DataCol = 1) then
    begin
      // The next is not neccesary but you can use it to adjust your text appearance.
      // you can change colors, font, size, as well other parameters.
      MyTextStyle := TDBGrid(Sender).Canvas.TextStyle;
      MyTextStyle.SingleLine := False;
      MyTextStyle.Wordbreak  := False;
      MyTextStyle.Layout := tlTop;
      TDBGrid(Sender).Canvas.TextStyle := MyTextStyle;

      // Here how to show any text:
      // just assign an event procedure to OnGetText of the Field.
      Column.Field.OnGetText := @Self.DBGridOnGetText;
    end;
end;

procedure TfrmGuidance.DBGridOnGetText(Sender: TField; var aText: string;
  DisplayText: Boolean);
begin
  if (DisplayText) then
		aText := Sender.AsString;
end;


end.

