unit mainmod;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IBConnection, sqldb, db, FileUtil, DbCtrls, Dialogs;

type

  { TdmMain }

  TdmMain = class(TDataModule)
    conGov: TIBConnection;
    dsrEmp: TDataSource;
    dsrOrg: TDataSource;
    dsrSite: TDataSource;
    qrySite: TSQLQuery;
    qryOrg: TSQLQuery;
    qryEmp: TSQLQuery;
    qryDocLocation: TSQLQuery;
    trnLookup: TSQLTransaction;
    trnMain: TSQLTransaction;
    procedure conGovBeforeConnect(Sender: TObject);
    procedure conGovLog(Sender: TSQLConnection; EventType: TDBEventType;
      const Msg: String);
    function Login(ADataBase :TIBConnection; APath, AName, APassword :String):
        Boolean;
    procedure Logout (ADatabase: TIBConnection);
    procedure Logout(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  dmMain: TdmMain;

implementation

{$R *.lfm}

{ TdmMain }

procedure TdmMain.conGovLog(Sender: TSQLConnection; EventType: TDBEventType;
  const Msg: String);
var FileName: string;
  LogFile: TextFile;
begin
  Filename := 'Mylog.log';
  AssignFile (LogFile, FileName);
  if FileExists (FileName) then
    Append(LogFile)
  else
    ReWrite(logFile);
  try
    Writeln(logFile, DateTimeToStr(now) + ': ' + Msg);
  finally
    CloseFile(LogFile);
  end;
end;

procedure TdmMain.conGovBeforeConnect(Sender: TObject);
  Var DocDir : String;
begin
  DocDir := ExtractFileDir(Paramstr(0));
  DocDir := DocDir + '\Db\test.FDB';
//  DocDir := StringReplace(DocDir,'\App','\Db\test.FDB',[]);
  dmMain.conGov.Connected:=False;
  dmMain.conGov.DatabaseName:=DocDir;
  dmMain.conGov.Password:='masterkey';
  dmMain.conGov.UserName:='sysdba';

end;

function TdmMain.Login(ADataBase: TIBConnection; APath, AName, APassword: String
  ): Boolean;
begin
  if ADatabase.Connected then
    ADatabase.Connected :=False;
  with ADatabase do
  begin
    aDatabase.UserName:= AName;
    aDatabase.Password:= APassword;
    aDatabase.DatabaseName:= APath;
  end;
  try
    ADataBase.Connected := True;

  except
    on E: ESQLDatabaseError do
      ShowMessageFmt('ErrorCode: %d; Message: %s', [E.ErrorCode, E.Message]);
  end;
  Result := ADatabase.Connected;
end;

procedure TdmMain.Logout(ADatabase: TIBConnection);
var Counter: Integer;
begin
  if not ADatabase.Connected then
    Exit;
  for Counter := 0 to ADatabase.TransactionCount -1 do
    if TSQLTransaction(ADatabase.Transactions[Counter]).Active then
      TSQLTransaction(ADatabase.Transactions[Counter]).Rollback;
  ADatabase.CloseDataSets;
end;

procedure TdmMain.Logout(Sender: TObject);
begin

end;


end.

